/*!
  * Copyright 2014,  Digital Reasoning
  *
  * Licensed under the Apache License, Version 2.0 (the "License");
  * you may not use this file except in compliance with the License.
  * You may obtain a copy of the License at
  *
  *     http://www.apache.org/licenses/LICENSE-2.0
  *
  * Unless required by applicable law or agreed to in writing, software
  * distributed under the License is distributed on an "AS IS" BASIS,
  * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
  * See the License for the specific language governing permissions and
  * limitations under the License.
  *
*/

define(["jquery","knockout","bootbox","utils/utils","select2"],function(e,t,n,r){"use strict";return function(){var i=this;i.breadcrumbs=[{active:!1,title:"Cloud Accounts",href:"/accounts/"},{active:!0,title:"New"}],i.providerSelector=e("#accountProvider"),i.regionSelector=e("#accountRegion"),i.vpcSelector=e("#accountVpcId"),i.sgSelector=e("#accountSecurityGroups"),i.newsgSelector=e("#accountSecurityGroupsNew"),i.providerSelector.select2({ajax:{url:"/api/cloud/providers/",dataType:"json",delay:100,data:function(e){return{name:e.term}},processResults:function(e){return e.results.forEach(function(e){e.text=e.name,e.id=e.name}),e},cache:!0},theme:"bootstrap",placeholder:"Select a provider...",templateResult:function(e){return e.loading?e.text:e.name},minimumInputLength:0}),i.regionSelector.select2({data:[],theme:"bootstrap",placeholder:"Select a region...",disabled:!0}),i.providerSelector.on("select2:select",function(e){var t=e.params.data;i.provider(t),i.regionSelector.select2({ajax:{url:t.regions,dataType:"json",delay:100,data:function(e){return{title:e.term}},processResults:function(e){return e.results.forEach(function(e){e.text=e.title,e.id=e.title}),e},cache:!0},theme:"bootstrap",disabled:!1,placeholder:"Select a region...",templateResult:function(e){return e.loading?e.text:e.title},minimumInputLength:0})}),i.regionSelector.on("select2:select",function(e){var t=e.params.data;i.region(t.title)}),i.sgSelector.select2({data:[],theme:"bootstrap",placeholder:"Select a security group...",disabled:!0}),i.newsgSelector.select2({data:[],theme:"bootstrap",disabled:!0}),i.wizard=e("#accountWizard"),i.wizard.on("actionclicked.fu.wizard",function(n,s){if(s.direction!=="next")return;i.removeErrors(i.keys);var o=!1;switch(s.step){case 1:i.provider()||(r.addError("#provider",["May not be blank"]),o=!0),i.title()||(r.addError("#title",["May not be blank"]),o=!0),i.vpcEnabled()&&!i.vpcId()&&(r.addError("#vpc_id",["May not be blank"]),o=!0),i.region()||(r.addError("#region",["May not be blank"]),o=!0),!o&&i.previousProvider!==i.provider().name&&(i.previousProvider=i.provider().name,e.ajax({method:"GET",url:i.provider().required_fields}).done(function(e){var n=[];e.results.forEach(function(e){if(e!=="private_key"){var r={apiName:e,displayName:i.extrasMap[e],fieldValue:t.observable()};e==="secret_access_key"?r.type="password":r.type="text",n.push(r)}}),i.extraFields(n)}));break;case 2:i.createCloudAccount().done(function(e){i.selectedAccount=e,i.makeSGSelector(e)}).done(function(){i.wizard.wizard("selectedItem",{step:3})}).fail(function(e){try{var t=JSON.parse(e.responseText),n=!1;i.keys.forEach(function(e){t.hasOwnProperty(e)&&(n=!0)}),n?i.wizard.wizard("selectedItem",{step:1}):i.wizard.wizard("selectedItem",{step:2})}catch(r){i.wizard.wizard("selectedItem",{step:1})}}),n.preventDefault();break;case 3:var u=i.sgSelector.select2("data"),a=i.newsgSelector.select2("data");console.log(u),console.log(a);var f=[];u.forEach(function(t){f.push(e.ajax({method:"POST",url:i.selectedAccount.security_groups,data:JSON.stringify({group_id:t.group_id,"default":!0})}))}),a.forEach(function(t){f.push(e.ajax({method:"POST",url:i.selectedAccount.security_groups,data:JSON.stringify({name:t.text,"default":!0})}))}),e.when.apply(this,f).done(function(){window.location="/accounts/"}).fail(function(e){r.alertError(e,"Error saving permissions")})}o&&n.preventDefault()}),i.keys=["provider","title","description","create_security_groups","vpc_id","region"],i.extrasMap={account_id:"Account ID",access_key_id:"Access Key ID",secret_access_key:"Secret Access Key",keypair:"Keypair Name",private_key:"Private Key",route53_domain:"Route 53 Domain"},i.previousProvider=null,i.provider=t.observable(),i.title=t.observable(),i.description=t.observable(),i.vpcEnabled=t.observable(),i.vpcId=t.observable(),i.region=t.observable(),i.createSecurityGroups=t.observable(),i.privateKey=t.observable(),i.extraFields=t.observableArray([]),i.securityGroups=t.observableArray([]),i.selectedAccount=null,i.sgSubscription=null,i.vpcSubscription=null,i.makeSGSelector=function(e){i.sgSelector.select2({ajax:{url:e.all_security_groups,dataType:"json",delay:100,data:function(e){return{name:e.term}},processResults:function(e){var t=[];return e.results.forEach(function(e){e.text=e.name,e.id=e.name,t.push(e)}),{results:t}},cache:!0},theme:"bootstrap",disabled:!1,placeholder:"Select a security group...",minimumInputLength:0}),i.newsgSelector.select2({theme:"bootstrap",tags:!0,tokenSeparators:[","]})},i.reset=function(){i.sgSubscription&&i.sgSubscription.dispose(),i.vpcSubscription&&i.vpcSubscription.dispose();var t=e("#sg-checkbox");i.sgSubscription=i.createSecurityGroups.subscribe(function(e){e?t.checkbox("check"):t.checkbox("uncheck")});var n=e("#vpc-checkbox");i.vpcSubscription=i.vpcEnabled.subscribe(function(e){e?n.checkbox("check"):n.checkbox("uncheck")}),i.provider(null),i.title(""),i.description(""),i.vpcEnabled(!0),i.createSecurityGroups(!0),i.vpcId(""),i.region(null),i.extraFields([]),i.securityGroups([])},i.removeErrors=function(t){t.forEach(function(t){var n=e("#"+t);n.removeClass("has-error");var r=n.find(".help-block");r.remove()})},i.createCloudAccount=function(){var t=i.keys.slice(),r={provider:i.provider().name,title:i.title(),description:i.description(),create_security_groups:i.createSecurityGroups(),private_key:i.privateKey(),region:i.region()};return i.vpcEnabled()?r.vpc_id=i.vpcId():r.vpc_id="",i.extraFields().forEach(function(e){r[e.apiName]=e.fieldValue(),t.push(e.apiName)}),i.removeErrors(t),e.ajax({method:"POST",url:"/api/cloud/accounts/",data:JSON.stringify(r)}).fail(function(r){var i="";try{var s=JSON.parse(r.responseText);for(var o in s)if(s.hasOwnProperty(o))if(t.indexOf(o)>=0){var u=e("#"+o);u.addClass("has-error"),s[o].forEach(function(e){u.append('<span class="help-block">'+e+"</span>")})}else if(o==="non_field_errors")s[o].forEach(function(t){if(t.indexOf("title")>=0){var n=e("#title");n.addClass("has-error"),n.append('<span class="help-block">An account with this title already exists.</span>')}});else{var a=o.replace("_"," ");s[o].forEach(function(e){i+="<dt>"+a+"</dt><dd>"+e+"</dd>"})}i&&(i='<dl class="dl-horizontal">'+i+"</dl>")}catch(f){i="Oops... there was a server error.  This has been reported to your administrators."}i&&n.alert({title:"Error creating account",message:i})})},i.reset()}});